#ifndef CASE_HPP
#define CASE_HPP

#include <iostream.h>
#include <stdlib.h>
#include "Listes.hpp"
#include "Quintuplet.hpp"
#include "Const.hpp"

class Quintuplet;
class Liste_quintuplets;
class Liste_cases;

class Case{
 private:
  int etat; //0 (ou VIDE) pour vide, 1 (ou CROIX) pour  X, 2 (ou ROND) pour 0, 9 (ou NONE)
  int valeur; //valeur de la case  
  Liste_quintuplets* quintuplets; //pointeur sur quintuplets qui contiennent la case
  Liste_cases* cases_voisines; //pointeur sur la liste des cases voisines
 public:
  Case(void);
  void ajoute_quintuplet(Quintuplet* quint); //ajoute un quint a la liste 'quintuplets'
  void ajoute_case_voisine(Case* Xcase); //ajoute une case a la liste 'cases_voisines'
  int calcule_valeur(void); //met a jour le champ 'valeur'
  int retourne_valeur(void);
  int retourne_etat(void);
  int mise_a_jour(int val_etat); /*met un 'pion' sur la case et met a jour la valeur
				   des quintutplets passant par la case, de la case
				   courante et des cases voisines */
  void reset(void); //remet a VIDE l'etat de la case
  void reinitialise(void); //reinit la valeur de la case pour recommencer une partie
  // Pour le debuggage:
  void affiche(void); //affiche la valeur d'une case sur la ligne de commande
};

#endif


