#include "perdu.xpm"
#include "gagne.xpm"
#include "question.xpm"
#include "exclamation.xpm"
#include "new_deal.xpm"
#include "OK.xpm"
#include "Interface.hpp"


/*********************************
  Gestion de la fenetre principale
**********************************/

void changer_bouton(GtkObject* Case_graphique, int tab_coups[N][N]){ //remet a jour une case
  //on commence par recuperer les coord de la case courante
  int x,y;
  char* nom = gtk_widget_get_name(GTK_WIDGET(Case_graphique));
  sscanf(nom,"%i:%i",&x,&y);
  //on met a jour cette case
  switch(tab_coups[y][x]){
  case NONE: //la case n'a pas changee -> on ne fait rien
    break;
  case VIDE: //la case a ete liberee
    gtk_widget_set(GTK_WIDGET(Case_graphique),"label"," ",NULL);
      break;
  case CROIX:
    gtk_widget_set(GTK_WIDGET(Case_graphique),"label","X",NULL);
    break;
  case ROND:
    gtk_widget_set(GTK_WIDGET(Case_graphique),"label","O",NULL);
    break;
  default: //cas impossible -> on le signal par ? si il arrivait
    gtk_widget_set(GTK_WIDGET(Case_graphique),"label","?",NULL);
  }
}

void sauver(GtkObject* Fenetre){ //sauvegarde la partie ds 'fichier_courant'
  Plateau* plateau = (Plateau*) gtk_object_get_data(Fenetre,"plateau");
  char *fichier;
  if ((fichier=plateau->sauvegarder(NULL)) != NULL){ //la sauvegarde a ete faite
    boite_info(GTK_WIDGET(Fenetre), SAVE_OK, fichier); //confirme au joueur que la sauvegarde a ete faite
  }
  else{ //il n'y a pas de fichier courant -> impossible de faire de sauvegarde -> demande d'en selectionner un
    boite_sauvegarder(GTK_WIDGET(Fenetre));
  }
}

void quitter(GtkWidget* Table){ //quitte le pgm (boite de dialogue)
  boite_dialogue(Table,QUITTER);
}

void recommencer(GtkWidget* Table){ //recommence une nouvelle partie (boite de dialogue)
  boite_dialogue(Table,RECOMMENCE_PARTIE);
}

void annuler_un_coup(GtkWidget* Table){ //le joueur demande d'annuler son dernier coup
  Plateau* plateau = (Plateau*) gtk_object_get_data(GTK_OBJECT(Table),"plateau");
  Coup coup; //pour stocker les coord de la case  qu'il faudra remettre a " "
  int tab_coups[N][N] ; //tab ou on va stocker le coup a annuler
  for (int i=0; i<N; i++){
    for (int j=0; j<N; j++){
      tab_coups[i][j] = NONE;
    }
  }
  //qd le joueur annule son coup, il faut aussi annuler le coup de l'ordi qui a joue juste apres lui
  for (int i=0; i<2; i++){
    if (plateau->annuler_coup(&coup) == 0){ //un coup a reellement ete annule
      tab_coups[coup._y][coup._x] = VIDE;
      gtk_container_foreach(GTK_CONTAINER(Table),(GtkSignalFunc)changer_bouton,(gpointer)tab_coups);
    }
  }
}

void jouer_auto(GtkWidget* Table){ //l'ordi joue ds une case
  Plateau* plateau = (Plateau*) gtk_object_get_data(GTK_OBJECT(Table),"plateau");
  int tab_coups[N][N] ; //tab ou on va stocker le coup a annuler
  for (int i=0; i<N; i++){
    for (int j=0; j<N; j++){
      tab_coups[i][j] = NONE;
    }
  }
  int x,y;
  switch(plateau->jouer_automatique(&x,&y)){
  case 0: //tout s'est passe normalement
    tab_coups[y][x] = ROND;
    gtk_container_foreach(GTK_CONTAINER(Table),(GtkSignalFunc)changer_bouton,(gpointer)tab_coups);
    break;
  case 2: //l'ordi a gagne
    tab_coups[y][x] = ROND;
    gtk_container_foreach(GTK_CONTAINER(Table),(GtkSignalFunc)changer_bouton,(gpointer)tab_coups);
    boite_dialogue(Table, JOUEUR_PERD);
    break;
  default: //erreur inconnue
    exit(EXIT_FAILURE);
  }
}

void jouer_manu(GtkObject* Case_graphique, GtkWidget* Table){ //le joueur joue ds une case
  Plateau* plateau = (Plateau*) gtk_object_get_data(GTK_OBJECT(Table),"plateau");
  //on commence par recuperer les coord de la case cliquee
  int x,y;
  char* nom = gtk_widget_get_name(GTK_WIDGET(Case_graphique));
  sscanf(nom,"%i:%i",&x,&y);
  //on joue ds cette case
  switch ( plateau->jouer_manuel(x,y) ){
  case 0: //tt s'est bien passe -> on met une croix dans la case
    gtk_widget_set(GTK_WIDGET(Case_graphique),"label","X",NULL); //change la valeur de la case cliquee
    //l'ordi joue juste apres
    jouer_auto(Table);
    break;
  case -2: //la case est deja prise
    break;
  case 1: //le joueur a gagne
    gtk_widget_set(GTK_WIDGET(Case_graphique),"label","X",NULL); //change le texte de la case
    boite_dialogue(GTK_WIDGET(Case_graphique)->parent, JOUEUR_GAGNE);
    break;
  default: //erreur inconnue
    exit(EXIT_FAILURE);
  }
}

void changer_qui_commence(GtkWidget *Table){ //change celui qui doit commencer la partie
  Plateau* plateau = (Plateau*) gtk_object_get_data(GTK_OBJECT(Table),"plateau");
  plateau->change_qui_commence();
  boite_dialogue(Table,CHANGE_QUI_COMMENCE);
}

void fenetre_principale(Plateau* plateau){
  GtkWidget* Fenetre;
  GtkWidget* Table;
  GtkWidget* Case_graphique;
  GtkWidget* Vbox;
  GtkWidget* Menu_bar;
  GtkWidget* Menu;
  GtkWidget* Menu_item;

  char nom[6]; //stocke le nom des cases
  bool debut_partie = TRUE; //precise si on vient de commencer la partie

  // Fenetre principale
  Fenetre = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(Fenetre),"Gomoku - Nouvelle partie");
  gtk_window_set_position(GTK_WINDOW(Fenetre),GTK_WIN_POS_CENTER); //fenetre centree par defaut
  gtk_window_set_policy(GTK_WINDOW(Fenetre),TRUE,TRUE,FALSE); //permet le redimensionnement
  gtk_object_set_data(GTK_OBJECT(Fenetre),"plateau",(gpointer)plateau);
  // Connection des signaux de la fenetre principale 'delete' et 'destroy'
  gtk_signal_connect(GTK_OBJECT(Fenetre),"delete_event", (GtkSignalFunc)gtk_exit, plateau);
  gtk_signal_connect(GTK_OBJECT(Fenetre),"destroy", (GtkSignalFunc)gtk_exit, plateau);
  // Pour la mise en page
  Vbox = gtk_vbox_new(FALSE,0);
  gtk_container_add(GTK_CONTAINER(Fenetre),Vbox);

  // Creation et attachement de la table (=le plateau)
  Table = gtk_table_new(N,N,TRUE);
  gtk_widget_set_usize(Table,30*N,30*N); //taille par defaut du plateau 
  gtk_container_add(GTK_CONTAINER(Vbox),Table);
  gtk_object_set_data(GTK_OBJECT(Table),"plateau",(gpointer)plateau);
  // Remplissage de la table (creation des cases)
  for (int i=0; i<N;i++){
    for (int j=0; j<N; j++){
      sprintf(nom,"%i:%i",i,j); //abscysse:ordonne (num colonne:num ligne)
      Case_graphique = gtk_button_new_with_label(" "); //creation du bouton
      gtk_table_attach_defaults(GTK_TABLE(Table),Case_graphique,i,i+1,j,j+1);
      gtk_widget_set_name(GTK_WIDGET(Case_graphique),nom); //on remplit son champ name par ses coord
      gtk_signal_connect(GTK_OBJECT(Case_graphique),"clicked", (GtkSignalFunc)jouer_manu, Table);
    }
  }

  // Creation de la bar de menu
  Menu_bar = gtk_menu_bar_new();
  gtk_box_pack_start(GTK_BOX(Vbox),Menu_bar,FALSE,FALSE,0);
  gtk_box_reorder_child(GTK_BOX(Vbox),Menu_bar,0); //met la bar de menu au-dessus de la grille
  //menu Fichier
  Menu_item = gtk_menu_item_new_with_label("Fichier");
  gtk_menu_bar_append(GTK_MENU_BAR(Menu_bar),Menu_item);
  Menu = gtk_menu_new();
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(Menu_item),Menu);
  Menu_item = gtk_menu_item_new_with_label("Sauver la partie");
  gtk_signal_connect_object(GTK_OBJECT(Menu_item),"activate",(GtkSignalFunc)sauver,GTK_OBJECT(Fenetre));
  gtk_menu_append(GTK_MENU(Menu),Menu_item);
  Menu_item = gtk_menu_item_new_with_label("Sauver la partie sous...");
  gtk_menu_append(GTK_MENU(Menu),Menu_item);
  gtk_signal_connect_object(GTK_OBJECT(Menu_item),"activate",(GtkSignalFunc)boite_sauvegarder,GTK_OBJECT(Fenetre));
  Menu_item = gtk_menu_item_new_with_label("Charger une partie");
  gtk_menu_append(GTK_MENU(Menu),Menu_item);
  gtk_signal_connect_object(GTK_OBJECT(Menu_item),"activate",(GtkSignalFunc)boite_charger,GTK_OBJECT(Table));
  Menu_item = gtk_menu_item_new(); //separateur
  gtk_menu_append(GTK_MENU(Menu),Menu_item);
  Menu_item = gtk_menu_item_new_with_label("Quitter");
  gtk_menu_append(GTK_MENU(Menu),Menu_item);
  gtk_signal_connect_object(GTK_OBJECT(Menu_item),"activate",(GtkSignalFunc)quitter,GTK_OBJECT(Table));
  //menu Jeu
  Menu_item = gtk_menu_item_new_with_label("Jeu");
  gtk_menu_bar_append(GTK_MENU_BAR(Menu_bar),Menu_item);
  Menu = gtk_menu_new();
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(Menu_item),Menu);
  Menu_item = gtk_menu_item_new_with_label("Annuler un coup");
  gtk_menu_append(GTK_MENU(Menu),Menu_item);
  gtk_signal_connect_object(GTK_OBJECT(Menu_item),"activate",(GtkSignalFunc)annuler_un_coup,GTK_OBJECT(Table));
  Menu_item = gtk_menu_item_new(); //separateur
  gtk_menu_append(GTK_MENU(Menu),Menu_item);
  Menu_item = gtk_menu_item_new_with_label("Recommencer partie");
  gtk_menu_append(GTK_MENU(Menu),Menu_item);
  gtk_signal_connect_object(GTK_OBJECT(Menu_item),"activate",(GtkSignalFunc)recommencer,GTK_OBJECT(Table));
  //menu Preferances
  Menu_item = gtk_menu_item_new_with_label("Preferances");
  gtk_menu_bar_append(GTK_MENU_BAR(Menu_bar),Menu_item);
  Menu = gtk_menu_new();
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(Menu_item),Menu);
  Menu_item = gtk_menu_item_new_with_label("Qui commence ?");
  gtk_menu_append(GTK_MENU(Menu),Menu_item);
  Menu = gtk_menu_new();
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(Menu_item),Menu);
  GSList *Groupe = NULL;
  Menu_item = gtk_radio_menu_item_new_with_label(Groupe, "Ordinateur");
  gtk_menu_append(GTK_MENU(Menu),Menu_item);
  Groupe = gtk_radio_menu_item_group(GTK_RADIO_MENU_ITEM(Menu_item));
  Menu_item = gtk_radio_menu_item_new_with_label(Groupe, "Joueur");
  gtk_menu_append(GTK_MENU(Menu),Menu_item);
  gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(Menu_item),TRUE); //par defaut c'est le joueur qui commence
  gtk_signal_connect_object(GTK_OBJECT(Menu_item),"toggled",(GtkSignalFunc)changer_qui_commence,GTK_OBJECT(Table));

  // On affiche tout
  gtk_widget_show_all(Fenetre);
}


/*******************************
  Gestion des boites de dialogue
********************************/

void rien(void){ //pour empecher de fermer la boite de dialogue avec 'close'
}

void reset_bouton(GtkObject* Case_graphique){ //RAZ d'une seule case
  gtk_widget_set(GTK_WIDGET(Case_graphique),"label"," ",NULL);
}

void reset_plateau(GtkObject* Table){ //RAZ du plateau entier
  Plateau* plateau = (Plateau*) gtk_object_get_data(Table,"plateau");
  //remise a zero de tout le plateau (vide les cases et supprime le fichier courant)
  plateau->restart();
  //supprime le nom du fichier ds le titre de l'application
  gtk_window_set_title(GTK_WINDOW(gtk_widget_get_toplevel(GTK_WIDGET(Table))),"Gomoku - Nouvelle partie");
  //remet " " ds toutes les boutons de la grille
  gtk_container_foreach(GTK_CONTAINER(Table),(GtkSignalFunc)reset_bouton,NULL);
  if (plateau->dit_qui_commence() == ORDI_COMMENCE)
    jouer_auto(GTK_WIDGET(Table)); //L'ordi joue maintenant si c'est lui qui doit commencer
}

void boite_dialogue(GtkWidget* Table, int type){ //mise en place et affichage de la boite de dialogue
  GtkWidget* Dialogue;
  GtkWidget* Bouton;
  GtkWidget* Texte;
  GtkWidget* Hbox;
  GtkWidget* Icone;
  GdkPixmap *Pix;
  GdkBitmap *Masque;
  GdkColor Transparent;

  char *info, *txt_b1, *txt_b2, *titre;
  static char **_xpm;
  Plateau* plateau = (Plateau*) gtk_object_get_data(GTK_OBJECT(Table),"plateau");

  /* Mise en place des param specifiques aux differentes boites de dialogue */
  switch (type){
  case JOUEUR_GAGNE:
    _xpm = gagne_xpm;
    info = "Felicitation, vous avez gagne.\nVoulez-vous rejouer?";
    txt_b1 = "Rejouer";
    txt_b2 = " Quitter Gomoku ";
    titre = "Rejouer?";
    break;
  case JOUEUR_PERD:
    _xpm = perdu_xpm;
    info = "Bahhhhh!! Vous avez perdu...\nVoulez-vous reessayer?";
    txt_b1 = " Retenter le coup ";
    txt_b2 = " Quitter Gomoku ";
    titre = "Rejouer?";
    break;
  case RECOMMENCE_PARTIE:
    _xpm = question_xpm;
    info = "Etes-vous vraiment sur de\nvouloir recommencer la partie?";
    txt_b1 = " Recommencer ";
    txt_b2 = " Continuer la partie ";
    titre = "Recommencer?";
    break;
  case CHANGE_QUI_COMMENCE:
    _xpm = new_deal_xpm;
    if (plateau->dit_qui_commence() == ORDI_COMMENCE)
      info = "L'ordinateur jouera en premier\na la prochaine partie.\nVoulez-vous recommencer\ntout de suite?";
    else
      info = "Vous jouerez en premier\na la prochaine partie.\nVoulez-vous recommencer\ntout de suite?";
    txt_b1 = " Recommencer ";
    txt_b2 = " Continuer la partie ";
    titre = "Recommencer tout de suite?";
    break;
  case QUITTER:
    _xpm = question_xpm;
    info = "Etes-vous vraiment sur de\nvouloir quitter Gomoku?";
    txt_b1 = " Continuer ";
    txt_b2 = " Quitter Gomoku ";
    titre = "Quitter?";
    break;
  }

  /* Creation de la boite de dialogue */
  Dialogue = gtk_dialog_new();
  gtk_window_set_title(GTK_WINDOW(Dialogue),titre); //donne un titre a la fenetre
  gtk_window_set_modal(GTK_WINDOW(Dialogue),TRUE); //Fenetre modale ... au dessus de sa fenetre principale
  gtk_window_set_transient_for(GTK_WINDOW(Dialogue), GTK_WINDOW(gtk_widget_get_toplevel(Table)));
  gtk_window_set_position(GTK_WINDOW(Dialogue),GTK_WIN_POS_CENTER); //apparait au milieu du plateau
  gtk_widget_set_usize(Dialogue,350,160); //dimensions initiales
  gtk_window_set_policy(GTK_WINDOW(Dialogue),FALSE,FALSE,FALSE); //non redimensionnable
  gtk_container_set_border_width(GTK_CONTAINER(Dialogue),10);

  /* Creation du texte d'information */
  Hbox = gtk_hbox_new(FALSE,5);
  gtk_container_add(GTK_CONTAINER(GTK_DIALOG(Dialogue)->vbox),Hbox);
  //la partie texte
  Texte = gtk_label_new(info);
  gtk_label_set_justify(GTK_LABEL(Texte),GTK_JUSTIFY_LEFT);
  //l'icone
  gtk_widget_realize(Dialogue);
  Pix = gdk_pixmap_create_from_xpm_d(Dialogue->window,&Masque,&Transparent,_xpm);
  Icone = gtk_pixmap_new(Pix,Masque);
  gdk_pixmap_unref(Pix);
  gdk_pixmap_unref(Masque);
  //disposition
  gtk_container_add(GTK_CONTAINER(Hbox),Icone);
  gtk_container_add(GTK_CONTAINER(Hbox),Texte);

  /* Creation des boutons */
  //le bouton "Rejouer" (ferme la boite de dialogue et le pgm reprend ou il s'etait arrete)
  Bouton = gtk_button_new_with_label(txt_b1);
  gtk_container_add(GTK_CONTAINER(GTK_DIALOG(Dialogue)->action_area),Bouton);
  switch (type){
  case JOUEUR_GAGNE: //meme chose que JOUEUR_PERD
  case CHANGE_QUI_COMMENCE: //meme chose que JOUEUR_PERD
  case RECOMMENCE_PARTIE: //meme chose que JOUEUR_PERD
  case JOUEUR_PERD:
    gtk_signal_connect_object(GTK_OBJECT(Bouton),"clicked",
			      (GtkSignalFunc)reset_plateau,GTK_OBJECT(Table)); //RAZ du plateau
    break;
  case QUITTER:
    break; //ne fait rien -> continue la partie en cours
  }
  gtk_signal_connect_object_after(GTK_OBJECT(Bouton),"clicked",
			    (GtkSignalFunc)gtk_widget_destroy,GTK_OBJECT(Dialogue)); //detruit la boite
  //le bouton "Quitter" ou autre...
  Bouton = gtk_button_new_with_label(txt_b2);
    gtk_container_add(GTK_CONTAINER(GTK_DIALOG(Dialogue)->action_area),Bouton);
  switch (type){
  case JOUEUR_GAGNE: //meme chose que JOUEUR_PERD
  case QUITTER: //meme chose que JOUEUR_PERD
  case JOUEUR_PERD:
    gtk_signal_connect(GTK_OBJECT(Bouton),"clicked",(GtkSignalFunc)gtk_exit,NULL); //quitte le pgm
    break;
  case CHANGE_QUI_COMMENCE: //meme chose que RECOMMENCE_PARTIE
  case RECOMMENCE_PARTIE:
    break; //ne fait rien -> continue la partie en cours
  }
  gtk_signal_connect_object_after(GTK_OBJECT(Bouton),"clicked",
				  (GtkSignalFunc)gtk_widget_destroy,GTK_OBJECT(Dialogue)); //detruit la boite

  //Traitement le signal close -> oblige a utiliser les boutons
  gtk_signal_connect(GTK_OBJECT(Dialogue),"delete_event",(GtkSignalFunc)rien,NULL);
  gtk_widget_show_all(GTK_WIDGET(Dialogue));
}


/***************************
  Gestion des boites d'info
****************************/

void boite_info(GtkWidget* Fenetre, int type, char* fichier){ //mise en place et affichage de la boite d'info
  GtkWidget* Info;
  GtkWidget* Bouton;
  GtkWidget* Texte;
  GtkWidget* Hbox;
  GtkWidget* Icone;
  GdkPixmap *Pix;
  GdkBitmap *Masque;
  GdkColor Transparent;

  char *info, *titre;
  static char **_xpm;

  /* Mise en place des param specifiques aux differentes boites de dialogue */
  switch (type){ 
  case SAVE_OK:
    _xpm = OK_xpm;
    info = new char[strlen("\nPartie sauvegardee sous:\n  ")+strlen(fichier)];
    sprintf(info,"\nPartie sauvegardee ds:\n%s\n",fichier);
    titre = "Info sauvegarde";
    break;
  case CHARGE_OK:
    _xpm = OK_xpm;
    info = new char[strlen("\nPartie chargee a partir de:\n  ")+strlen(fichier)];
    sprintf(info,"\nPartie chargee a partir de:\n%s\n",fichier);
    titre = "Info chargement";
    break;
  case CHARGE_NOT_OK:
    _xpm = exclamation_xpm;
    info = "Tentative de chargement avortee.\nVerifiez que le fichier selectionne existe\net est bien une sauvegarde de partie.";
    titre = "Info chargement";
    break;
  }

  /* Creation de la boite de dialogue */
  Info = gtk_dialog_new();
  gtk_window_set_title(GTK_WINDOW(Info),titre); //donne un titre a la fenetre
  gtk_window_set_modal(GTK_WINDOW(Info),TRUE); //Fenetre modale ... au dessus de sa fenetre principale
  gtk_window_set_transient_for(GTK_WINDOW(Info), GTK_WINDOW(Fenetre));
  gtk_window_set_position(GTK_WINDOW(Info),GTK_WIN_POS_CENTER); //apparait au milieu du plateau
  gtk_window_set_policy(GTK_WINDOW(Info),FALSE,FALSE,FALSE); //non redimensionnable
  gtk_container_set_border_width(GTK_CONTAINER(Info),10);

  /* Creation du texte d'information */
  Hbox = gtk_hbox_new(FALSE,5);
  gtk_container_add(GTK_CONTAINER(GTK_DIALOG(Info)->vbox),Hbox);
  //la partie texte
  Texte = gtk_label_new(info);
  gtk_label_set_justify(GTK_LABEL(Texte),GTK_JUSTIFY_LEFT);
  //l'icone
  gtk_widget_realize(Info);
  Pix = gdk_pixmap_create_from_xpm_d(Info->window,&Masque,&Transparent,_xpm);
  Icone = gtk_pixmap_new(Pix,Masque);
  gdk_pixmap_unref(Pix);
  gdk_pixmap_unref(Masque);
  //disposition
  gtk_container_add(GTK_CONTAINER(Hbox),Icone);
  gtk_container_add(GTK_CONTAINER(Hbox),Texte);

  /* Creation des boutons */
  //le bouton "Rejouer" (ferme la boite de dialogue et le pgm reprend ou il s'etait arrete)
  Bouton = gtk_button_new_with_label("OK");
  gtk_container_add(GTK_CONTAINER(GTK_DIALOG(Info)->action_area),Bouton);
  gtk_signal_connect_object(GTK_OBJECT(Bouton),"clicked",
			    (GtkSignalFunc)gtk_widget_destroy,GTK_OBJECT(Info)); //detruit la boite

  //Traitement le signal close -> oblige a utiliser les boutons
  gtk_signal_connect(GTK_OBJECT(Info),"delete_event",(GtkSignalFunc)rien,NULL);
  gtk_widget_show_all(GTK_WIDGET(Info));
}


/*********************************
  Gestion des boites de selection
**********************************/

void sauver_sous(GtkFileSelection *SelFichier, GtkObject* Bouton){ /* sauvegarde la partie ds le fichier 
								      selectionne ds 'boite_sauvegarder' */
  GtkWidget* Fenetre = (GtkWidget*)  gtk_object_get_data(Bouton,"fenetre");
  Plateau* plateau = (Plateau*) gtk_object_get_data(GTK_OBJECT(Fenetre),"plateau");
  char* fichier= new char[strlen(gtk_file_selection_get_filename(SelFichier))+1]; /*necessaire pour conserver 
										    correctement le nom du fichier
										    par la suite */
  sprintf(fichier,"%s",gtk_file_selection_get_filename(SelFichier));
  if (plateau->sauvegarder(fichier) != NULL){ //la sauvegarde a ete faite
    //on met ds le titre de l'application le nom du fichier ds lequel on travail maintenant
    char* titre = new char[strlen("Gomoku -  ")+strlen(fichier)];
    sprintf(titre,"Gomoku - %s",fichier);
    gtk_window_set_title(GTK_WINDOW(Fenetre),titre);
    boite_info(Fenetre, SAVE_OK, fichier); //confirme au joueur que la sauvegarde a ete faite
  }
}

void boite_sauvegarder(GtkWidget *Fenetre){ //Boite pour selectionner un fichier a sauvegarder
  GtkFileSelection *SelFichier;

  /* Creation et gestion de la boite de selection */
  SelFichier = (GtkFileSelection*) gtk_file_selection_new("Sauvegarder une partie...");
  //proprietes
  gtk_window_set_modal(GTK_WINDOW(SelFichier),TRUE); //Fenetre modale ... au dessus de sa fenetre principale
  gtk_window_set_transient_for(GTK_WINDOW(SelFichier), GTK_WINDOW(Fenetre));
  gtk_window_set_position(GTK_WINDOW(SelFichier),GTK_WIN_POS_CENTER); //apparait au milieu du plateau
  //gestion des signaux delete et close -> on sort de la boite et on revient a la partie
  gtk_signal_connect_object(GTK_OBJECT(SelFichier),"delete_event",(GtkSignalFunc)gtk_widget_destroy,
			    GTK_OBJECT(SelFichier));
  gtk_signal_connect_object(GTK_OBJECT(SelFichier),"destroy",(GtkSignalFunc)gtk_widget_destroy,
			    GTK_OBJECT(SelFichier));

  /* Gestion des boutons */
  //bouton OK
  gtk_object_set_data(GTK_OBJECT(SelFichier->ok_button),"fenetre",(gpointer)Fenetre); //pour la fct sauver_sous
  gtk_signal_connect_object(GTK_OBJECT(SelFichier->ok_button),"clicked",(GtkSignalFunc)sauver_sous,
			    GTK_OBJECT(SelFichier)); // passe le fichier selectionne a la fct sauver_sous
  gtk_signal_connect_object_after(GTK_OBJECT(SelFichier->ok_button),"clicked",
				  (GtkSignalFunc)gtk_widget_destroy,GTK_OBJECT(SelFichier)); //detruit la boite
  //bouton Cancel
  gtk_signal_connect_object(GTK_OBJECT(SelFichier->cancel_button),"clicked",
			    (GtkSignalFunc)gtk_widget_destroy,GTK_OBJECT(SelFichier)); //detruit la boite

  /* Affiche la boite */
  gtk_widget_show(GTK_WIDGET(SelFichier));
}

void charger(GtkFileSelection *SelFichier, GtkObject* Bouton){ /* charge une partie selectionne
								  a partir de 'boite_charger' */
  GtkWidget *Table = (GtkWidget*)  gtk_object_get_data(Bouton,"table");
  GtkWidget *Fenetre = gtk_widget_get_toplevel(Table);
  Plateau* plateau = (Plateau*) gtk_object_get_data(GTK_OBJECT(Table),"plateau");
  char* fichier= new char[strlen(gtk_file_selection_get_filename(SelFichier))+1]; /*necessaire pour conserver 
										    correctement le nom du fichier
										    par la suite */
  sprintf(fichier,"%s",gtk_file_selection_get_filename(SelFichier));
  int m;
  int tab_coups[N][N]={VIDE}; //tab ou on va stocker le nouvel etat de la liste de coups

  if ( (m=plateau->charger(fichier, tab_coups)) > 0){ //le fichier a ete charge
    //on met ds le titre de l'application le nom du fichier ds lequel on travail maintenant
    char* titre = new char[strlen("Gomoku -  ")+strlen(fichier)];
    sprintf(titre,"Gomoku - %s",fichier);
    gtk_window_set_title(GTK_WINDOW(gtk_widget_get_toplevel(Table)),titre);
    gtk_container_foreach(GTK_CONTAINER(Table),(GtkSignalFunc)changer_bouton,(gpointer)tab_coups);
    boite_info(Fenetre, CHARGE_OK, fichier); //confirme au joueur que la sauvegarde a ete faite
  }
  else{
    boite_info(Fenetre, CHARGE_NOT_OK, NULL); //informe le joueur que le chargement a echoue
  }
}

void boite_charger(GtkWidget *Table){ //Boite pour selectionner un fichier a charger
  GtkFileSelection *SelFichier;
  GtkWidget *Fenetre = gtk_widget_get_toplevel(Table);

  /* Creation et gestion de la boite de selection */
  SelFichier = (GtkFileSelection*) gtk_file_selection_new("Charger une partie...");
  //proprietes
  gtk_file_selection_hide_fileop_buttons(SelFichier); //simplifie la boite de selection
  gtk_window_set_modal(GTK_WINDOW(SelFichier),TRUE); //Fenetre modale ... au dessus de sa fenetre principale
  gtk_window_set_transient_for(GTK_WINDOW(SelFichier), GTK_WINDOW(Fenetre));
  gtk_window_set_position(GTK_WINDOW(SelFichier),GTK_WIN_POS_CENTER); //apparait au milieu du plateau
  //gestion des signaux delete et close -> on sort de la boite et on revient a la partie
  gtk_signal_connect_object(GTK_OBJECT(SelFichier),"delete_event",(GtkSignalFunc)gtk_widget_destroy,
			    GTK_OBJECT(SelFichier));
  gtk_signal_connect_object(GTK_OBJECT(SelFichier),"destroy",(GtkSignalFunc)gtk_widget_destroy,
			    GTK_OBJECT(SelFichier));

  /* Gestion des boutons */
  //bouton OK
  gtk_object_set_data(GTK_OBJECT(SelFichier->ok_button),"table",(gpointer)Table); //pour la fct charger
  gtk_signal_connect_object(GTK_OBJECT(SelFichier->ok_button),"clicked",(GtkSignalFunc)charger,
		     GTK_OBJECT(SelFichier)); // passe le fichier selectionne a la fct charger
  gtk_signal_connect_object_after(GTK_OBJECT(SelFichier->ok_button),"clicked",
				  (GtkSignalFunc)gtk_widget_destroy,GTK_OBJECT(SelFichier)); //detruit la boite
  //bouton Cancel
  gtk_signal_connect_object(GTK_OBJECT(SelFichier->cancel_button),"clicked",
			    (GtkSignalFunc)gtk_widget_destroy,GTK_OBJECT(SelFichier)); //detruit la boite

  /* Affiche la boite */
  gtk_widget_show(GTK_WIDGET(SelFichier));
}

