#include "Listes.hpp"

/*****************************************/
//liste simplement chainee de quintuplets
/*****************************************/

Liste_quintuplets::Liste_quintuplets(void){ //constructeur
  tete = NULL;
}

void Liste_quintuplets::ajouter(Quintuplet *quint){ //Ajoute un element a la liste
  Element_quint* temp = new Element_quint(quint);
  temp->suivant = tete;
  tete = temp;
}

bool Liste_quintuplets::non_vide(void){ //Verifie si la liste est vide ou non
  if (tete == NULL) return false;
  else return TRUE;
}

int Liste_quintuplets::retourne_valeur_liste(void){ /*Retourne la somme des valeur des quint
						      de la liste */
  int somme = 0;
  Element_quint *courant = tete;
  while (courant != NULL){
     somme += (courant->quint->retourne_valeur());
     courant = courant->suivant;
  }
  return somme;
}

int Liste_quintuplets::mise_a_jour(void){ /*Calcule la valeur de ts les quint de la liste
					    et retourne:
					    -1 en cas d'erreur 
					    0 si tt s'est bien passe
					    1 si au moins 1x 5 X allignees
					    2 si au moins 1x 5 O allignes */
  Element_quint *courant = tete;
  while (courant != NULL){
    switch(courant->quint->mise_a_jour()){
    case 0: //la mise a jour du quint courant s'est passee normalement
      break;
    case 1: //5 X ds le quint courant
      return 1;
      break;
    case 2: //5 O ds le quint courant
      return 2;
      break;
    default:
      return -1;
    }
    courant = courant->suivant;
  }
  return 0;
}

/***********************************/
//liste simplement chainee de cases
/***********************************/

Liste_cases::Liste_cases(void){ //constructeur
  tete = NULL;
}

bool Liste_cases::non_vide(void){ //Verifie si la liste est vide ou non
  if (tete == NULL) return false;
  else return TRUE;
}

void Liste_cases::ajouter(Case *Xcase){ //Ajoute une case a la liste
  Element_case* temp=new Element_case(Xcase);
  temp->suivant = tete;
  tete = temp;
}

void Liste_cases::calcule_valeur(void){ //Calcule la valeur de ttes les cases de la liste
  Element_case* temp = tete;
  while (temp != NULL){
    temp->CASE->calcule_valeur();
    temp = temp->suivant;
  }
}


/***********************************/
//liste doublement chainee de coups
/***********************************/

Liste_coups::Liste_coups(void){ //constructeur
  premier = NULL;
  dernier = NULL;
  nb = 0;
}

bool Liste_coups::non_vide(void){ //retourne TRUE si la liste est non vide
  if (dernier == NULL) return false;
  else return TRUE;
}

void Liste_coups::ajouter_coup(Coup _coup){ //ajoute un coup a la liste
  Element_coup *tmp = new Element_coup;
  tmp->_coup = _coup;
  tmp->precedant = dernier;
  tmp->suivant = NULL;
  if (premier == NULL){ //c'est le premier coup de la partie
    premier = tmp;
  }
  else dernier->suivant = tmp;
  dernier = tmp;
  nb++;
}

int Liste_coups::lire_dernier_coup(Coup* coup){ /* stocke le dernier coup joue ds 'coup' et retourne
						   0 en cas de reussite
						   -1 en cas d'echec (pas de coup a lire) */
  if (dernier != NULL){ //il reste au moins un coup ds la liste des coups joues
    coup->_x = dernier->_coup._x;
    coup->_y = dernier->_coup._y;
    coup->etat = dernier->_coup.etat;
    return 0;
  }
  else{ //aucun coup a lire
    return -1;
  }
}

void Liste_coups::effacer_dernier_coup(void){ //efface le dernier coup joue
  if (dernier != NULL){ //on a au moins deja joue un coup
    Element_coup *tmp = dernier;
    dernier = dernier->precedant;
    if (dernier != NULL) dernier->suivant = NULL; //on a au moins deja joue 2 coups
    else premier = NULL; //on a effacer le 1e coup
    delete tmp;
    nb--;
  }
}

void Liste_coups::sauvegarder(FILE* fic){ //sauve la liste des coups ds 'fic'
  Element_coup *courant = premier;
  int i=0;
  Coup* coup;
  if (fwrite("GOMOKU",sizeof(char),(size_t)6,fic) != 6){ /* Pour la fct de chargement: permet de tester la validite 
							    des fichiers que l'utilisateur demande d'ouvrir */
    perror("fwrite");
    exit(EXIT_FAILURE);
  }  
  while (courant != NULL){
    coup = &(courant->_coup);
    if (fwrite(coup,sizeof(Coup),(size_t)1,fic) != 1){
      perror("fwrite");
      exit(EXIT_FAILURE);
    }
    courant = courant->suivant;
  }
}

void Liste_coups::vider(void){ //vide la liste des coups
  while (dernier != NULL){
    effacer_dernier_coup();
  }
}

// Pour le debuggage:
void Liste_coups::afficher_tout(void){ //affiche tous les coups joues
  Element_coup *courant = dernier;
  int i=nb;
  while (courant != NULL){
    cout <<i<<"e coup: x="<<courant->_coup._x<<" y="<<courant->_coup._y<<" de "<<  courant->_coup.etat << endl;
    i--;
    courant = courant->precedant;
  }
}
