#ifndef LISTES_HPP
#define LISTES_HPP

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h> //utilise car <bool.h> n'existe pas (changement de derniere min)
#include "Quintuplet.hpp"
#include "Case.hpp"

class Case;
class Quintuplet;

/*****************************************/
//liste simplement chainee de quintuplets
/*****************************************/


class Element_quint{ //maillon de la liste chainee
public:
  //declarations
  Quintuplet *quint;
  Element_quint *suivant;
  //fonctions
  Element_quint(void){
    quint = NULL;
    suivant = NULL;
  };
  Element_quint(Quintuplet *Xquint){
    quint = Xquint;
    suivant = NULL;
  };
};

class Liste_quintuplets{
 private:
  Element_quint *tete; //1er element de la liste
 public:
  Liste_quintuplets(void); //constructeur de la liste de quint
  bool non_vide(void); //verifie si la liste est vide
  void ajouter(Quintuplet *quint); //ajoute un quintuplet a la liste
  int retourne_valeur_liste(void); //retourne la somme des valeurs des quintuplets
  int mise_a_jour(void); //calcule la valeur de ts les quint de la liste
};


/***********************************/
//liste simplement chainee de cases
/***********************************/

class Element_case{ //maillon de la liste chainee
public:
  //declarations
  Case *CASE; //rem: le mot 'case' est reserve
  Element_case *suivant;
  //fonctions
  Element_case(void){
    CASE = NULL;
    suivant = NULL;
  };
  Element_case(Case* Xcase){
    CASE = Xcase;
    suivant = NULL;
  };
};

class Liste_cases{ //liste simplement chainee
private:
  Element_case *tete; //1er element de la liste
public:
  Liste_cases(void); //constructeur de le liste de cases
  bool non_vide(void); //verifie si la liste est vide
  void ajouter(Case *Xcase); //Ajoute une case a la liste
  void calcule_valeur(void); //calcule la valeur de ttes les cases de la liste
};


/***********************************/
//liste doublement chainee de coups
/***********************************/

struct Coup{
  int _x; //num de la colonne ou on joue
  int _y; //num de la ligne ou on joue
  int etat; //qui joue
};

struct Element_coup{
  Coup _coup;
  Element_coup *precedant;
  Element_coup *suivant;
};

class Liste_coups{
  Element_coup *premier;
  Element_coup *dernier;
  int nb; //stocke le nb de coups joues
public:
  Liste_coups(void); //constructeur
  void ajouter_coup(Coup _coup); //ajoute un coup a la liste
  bool non_vide(void); //retourne true si la liste est non vide
  int lire_dernier_coup(Coup *coup); //stocke le dernier coup ds 'coup'
  void effacer_dernier_coup(void); //efface le dernier coup joue
  void sauvegarder(FILE* fic); //sauve la liste des coups ds 'fic'
  int liste_complete(char*** tab_liste); //retourne le nb de coups et place ts les coups ds *tab_liste[][]
  void vider(void); //vide la liste des coups
// Pour le debuggage:
  void afficher_tout(void); //affiche tous les coups joues
};

#endif

