#ifndef PLATEAU_HPP
#define PLATEAU_HPP

#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <iostream.h>
#include "Case.hpp"
#include "Const.hpp"
#include "Listes.hpp"

class Plateau{
private:
  Case *jeu[N][N]; //plateau du jeu
  Liste_coups* partie; //liste de sauvegarde des coups de la partie
  char* fichier_courant; //fichier par defaut ds lequel on sauvegarde la partie
  int qui_commence; //precise qui commence la partie: JOUEUR_COMMENCE=0, ORDI_COMMENCE=1
public:
  Plateau(void);
  int jouer_manuel(int j, int i); //le joueur joue a la case (x,y)
  int jouer_automatique(int *x, int *y); //l'ordinateur joue
  void restart(void); //remet le plateau ds son etat init
  int annuler_coup(Coup* coup); // annule le dernier coup et le stocke ds 'coup'
  char* sauvegarder(char* fichier); //sauvegarde la partie
  int charger(char* fichier,int tab_coup[N][N]); //charge une partie
  void change_qui_commence(void); //change celui qui doit commencer la partie
  int dit_qui_commence(void); //retourne qui doit commencer la partie
  //Pour le debuggage:
  void affiche(void); //affiche la valeur des cases du plateau
private:
  void initRandom(void); //initialise la fct random
  int random(int range); //genere un nb aleatoire entre 0 et range-1
};

#endif


