#include "Quintuplet.hpp"

Quintuplet::Quintuplet(Case * quintDef[5]){ //constructeur
  valeur = Vide_score; //on ne creer des quint qu'au demarrage du jeu; il est dc vide
  for (int i=0; i<5; i++){
    quint[i] = quintDef[i];
  }
}

int Quintuplet::retourne_valeur(void){ //retourne la valeur du quintuplet sans la recalculer
  return valeur;
}

int Quintuplet::mise_a_jour(void){ /*compte le nb de X et O et calcule la valeur du quint
				     retourne:
				     0 si rien de particulier
				     1 si le quint a 5 X
				     2 si le quint a 5 O
				     -1 en cas d'erreur */
  int compte[2] = {0,0}; /* On comptabilise le nb de X et O ds ce tableau
			    compte[0] donne le nb de X
			    compte[1] donne le nb de O */
  for (int i=0; i<5; i++){
    switch (quint[i]->retourne_etat()){
    case CROIX:
      compte[0]++;
      break;
    case ROND:
      compte[1]++;
      break;
    case VIDE:
      break;
    default: //pas d'autre cas possibles normalement
      cout << "Erreur ds le champ 'etat' d'une case" << endl;
      exit(EXIT_FAILURE);
    }
  }
  // On met a jour la valeur du quintuplet
  if (compte[0] == 0){ //si il n'y a pas de X, on compte le nb de O
     switch (compte[1]){
     case 0:
       valeur = Vide_score;
       break;
     case 1:
       valeur = O_score;
       break;
     case 2:
       valeur = OO_score;
       break;
     case 3:
       valeur = OOO_score;
       break;
     case 4:
       valeur = OOOO_score;
       break;
     case 5:
       return 2;
       break;
     default: //cas impossible sans erreur
       return -1;
     }
  }
  else{
    if (compte[1] != 0) valeur = OX_score; //il y a au moins une X et un O
    else{ //il n'y a pas de O, on compte le nb de X
      switch (compte[0]){
      case 1:
	valeur = X_score;
	break;
      case 2:
	valeur = XX_score;
	break;
      case 3:
	valeur = XXX_score;
	break;
      case 4:
	valeur = XXXX_score;
	break;
      case 5:
	return 1;
	break;
      default: //cas impossible sans erreur
	return -1;
      } 
    }
  }
  return 0;
}






